﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=StaticCode
Version=9.1
@EndOfDesignText@
' *#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*
' 
' B4X Sessions library started by ThRuST August 2, 2021.
' Please continue my work and add your name, date and notes to the history log.
' Original forum Post: https://www.b4x.com/android/forum/threads/poststring-with-php-session-variables.133084
' Remove the GUI and compile it to a library of just add the module B4XSessions to your project to use it.

' HISTORY LOG (Don't forget to update library version below and in Main #Region Project Attributes for B4X IDE)

' Current version: v0.2
' -----------
' User				Date				Notes
' ThRuST			2021-08-02			Started coding on B4X Sessions :-)
' ThRuST			2021-08-02			v.02 Update. Library now creates server cookies in the domain /Cookies subfolder.
' 
' 
' 
' 


' *#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*

' These PHP scripts are needed - Prefferably create.php for this example (Change in Public SETpath below)
' Store it on your domain and set the domain info before running code.

' *#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*
' (Create.php)

'<?php
'
'	// Recieve POST string To create Cookies subfolder
'	$CookieFolder 	= $_POST['CookieFolder'];
'	$CreateUID 		= $_POST['CreateUID'];
'
'	// Create Cookies folder
'	mkdir($CookieFolder);
'
'	// Change directory To Cookies folder
'	chdir($CookieFolder);
'
'	// Create Cookie File
'	$CookieCreate = fopen($CreateUID, "w")
'
'?>

'Static code module
Sub Process_Globals
	
	Private fx As JFX
	Private Tal1, Tal2, Tal3, Tal4, Tal5, Tal6, Tal7, Tal8 As Int
	
	Public UID As String
	
	Public DomainPath 	As String = "https://www.yourdomain.com" 	' NOTE: Forwardslash "/" not needed here
	Public SETPath 		As String = DomainPath & "/" & "create.php"	' PHP filename that creates the cookie file
	Public CookieFolder As String = "Cookies"						' The subfolder name to store session cookies
	
End Sub

' Generates a unique User Identification number.
' Usage: B4XSessions.GenerateUID(DestinationString)
' Access current UID from Public string variable B4XSessions.UID
Public Sub GenerateUID (x As String)
	
	Tal1  = Rnd(10000, 99999999999)
	Tal2  = Rnd(10000, 99999999999)
	Tal3  = Rnd(10000, 99999999999)
	Tal4  = Rnd(10000, 99999999999)
	Tal5  = Rnd(10000, 99999999999)
	Tal6  = Rnd(10000, 99999999999)
	Tal7  = Rnd(10000, 99999999999)
	Tal8  = Rnd(10000, 99999999999)
 
	UID = Tal1 & Tal2 & Tal3 & Tal4 & Tal5 & Tal6 & Tal7 & Tal8
 
 	' You might want to disable Log block below as it's for debug usage only.
 	Log("-------------------")
	Log("New generated UID:")
	Log(UID)
 
	Return UID
 
End Sub

' Returns the Domain path to B4X session cookies.
' Usage B4XSessions.DomainPath(DestinationString)
Public Sub Domain (x As String)
	
	Return DomainPath
	
End Sub

' Creates a session cookie on the server by calling online PHP script.
' Usage: B4XSessions.SETSession
Public Sub SETSession
	
	' Creates the UID file on the server PHP call script from here.
	
	Dim sendjob1 As HttpJob
	Dim response As String
    
	' Init okHttpUtils2
	sendjob1.Initialize("", Me)
    
	' Send multiple POST requests
	sendjob1.PostString(SETPath, _
    "CookieFolder=" & CookieFolder & _
    "&CreateUID=" & UID)
	
	Wait For (sendjob1) JobDone(sendjob1 As HttpJob)

	If sendjob1.Success Then
		'xui.MsgboxAsync("Data was successfully sent to server.", "")
 
		response = sendjob1.GetString
		Log("Log Start -----------------------------------------------------------")
		Log(response & " " & CRLF)
		Log("Log End -------------------------------------------------------------")
		
		'fx.ShowExternalDocument("https://www.")
		
	Else
		response = sendjob1.ErrorMessage
	End If
	'WebView1.LoadHtml(response)

	sendjob1.Release
	
End Sub

' Removes a session cookie on the server by calling online PHP script.
' Usage: B4XSessions.UNSETSession
Public Sub UNSETSession
	
	' Removes the UID file on the server PHP call script from here.
	' ...
	
End Sub
